%define _default_patch_fuzz 2
Summary: Library providing XML and HTML support
Name: libxml2
Version: 2.6.26
Release: 2.1.25%{?dist}
License: MIT
Group: Development/Libraries
Source: ftp://xmlsoft.org/libxml2-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: python python-devel zlib-devel
URL: http://xmlsoft.org/
Prefix: %{_prefix}
Docdir: %{_docdir}
Patch0: multilib.patch
Patch1: utf8_check.patch
Patch2: billion_laught.patch
Patch3: entity_name_buffer.patch
Patch4: CVE-2008-4225.patch
Patch5: CVE-2008-4226.patch
Patch6: ficora-245608.patch
Patch7: libxml2-2.6.26-xpath-fix.patch
# Patches fixing XSD validation
Patch8: libxml2-2.6.26-xsd-1.patch
Patch9: libxml2-2.6.26-xsd-2.patch
Patch10: libxml2-2.6.26-xsd-3.patch
Patch11: libxml2-2.6.26-xsd-4.patch
Patch12: libxml2-2.6.26-xsd-5.patch
Patch13: libxml2-2.6.26-xsd-6.patch
Patch14: libxml2-2.6.26-xsd-7.patch
Patch15: libxml2-2.6.26-xsd-8.patch
Patch16: libxml2-2.6.26-xsd-9.patch
Patch17: libxml2-2.6.26-xsd-10.patch
Patch18: libxml2-2.6.26-xsd-11.patch
Patch19: libxml2-2.6.26-xsd-12.patch
Patch20: libxml2-2.6.26-xsd-13.patch
Patch21: libxml2-2.6.26-xsd-14.patch
Patch22: libxml2-2.6.26-xsd-reject-empty-uints.patch
# Patches fixing CVE issues
Patch23: CVE-2010-4008_1.patch
Patch24: CVE-2010-4008_2.patch
Patch25: CVE-2011-0216.patch
Patch26: CVE-2011-1944.patch
Patch27: CVE-2011-2834.patch
Patch28: CVE-2011-3905.patch
Patch29: CVE-2011-3919.patch
Patch30: dict-no-mutex.patch
Patch31: dict-hash-algo.patch
Patch32: dict-hash-algo-fix.patch
Patch33: dict-hash-algo-fix2.patch
Patch34: dict-hash-cache.patch
Patch35: hash-scan-fix.patch
Patch36: CVE-2012-0841.patch
Patch37: force_randomization.patch
Patch38: libxml2-Fix-parser-local-buffers-size-problems.patch
Patch39: libxml2-Fix-entities-local-buffers-size-problems.patch
Patch40: libxml2-Fix-an-error-in-previous-commit.patch
Patch41: libxml2-Fix-an-off-by-one-pointer-access.patch
Patch42: libxml2-Implement-some-default-limits-in-the-XPath-module.patch
Patch43: libxml2-Change-the-XPath-code-to-percolate-allocation-errors.patch
Patch44: libxml2-Fix-potential-out-of-bound-access.patch
Patch45: libxml2-492317-Fix-Relax-NG-validation-problems.patch
Patch46: libxml2-Fixed-a-bug-in-xmlDOMWrapAdoptNode-the-tree-traversal-stopped-if-the.patch
Patch47: libxml2-Detect-excessive-entities-expansion-upon-replacement.patch
Patch48: libxml2-applied-documentation-patches-from-Markus-Keim-fixed-one-bug-and-added-a.patch
Patch49: libxml2-another-small-change-on-the-algorithm-for-the-elimination-of-epsilon.patch
Patch50: CVE-2014-3660-rhel5.patch


%description
This library allows to manipulate XML files. It includes support
to read, modify and write XML and HTML files. There is DTDs support
this includes parsing and validation even with complex DtDs, either
at parse time or later once the document has been modified. The output
can be a simple SAX stream or and in-memory DOM like representations.
In this case one can use the built-in XPath and XPointer implementation
to select subnodes or ranges. A flexible Input/Output mechanism is
available, with existing HTTP and FTP modules and combined to an
URI library.

%package devel
Summary: Libraries, includes, etc. to develop XML and HTML applications
Group: Development/Libraries
Requires: libxml2 = %{version}
Requires: zlib-devel
Requires: pkgconfig

%description devel
Libraries, include files, etc you can use to develop XML applications.
This library allows to manipulate XML files. It includes support 
to read, modify and write XML and HTML files. There is DTDs support
this includes parsing and validation even with complex DtDs, either
at parse time or later once the document has been modified. The output
can be a simple SAX stream or and in-memory DOM like representations.
In this case one can use the built-in XPath and XPointer implementation
to select subnodes or ranges. A flexible Input/Output mechanism is
available, with existing HTTP and FTP modules and combined to an
URI library.

%package python
Summary: Python bindings for the libxml2 library
Group: Development/Libraries
Requires: libxml2 = %{version}
Requires: %{_libdir}/python%(echo `python -c "import sys; print sys.version[0:3]"`)

%description python
The libxml2-python package contains a module that permits applications
written in the Python programming language to use the interface
supplied by the libxml2 library to manipulate XML files.

This library allows to manipulate XML files. It includes support 
to read, modify and write XML and HTML files. There is DTDs support
this includes parsing and validation even with complex DTDs, either
at parse time or later once the document has been modified.

%prep
%setup -q
%patch0 -p1
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0

%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1
%patch42 -p1
%patch43 -p1
%patch44 -p1
%patch45 -p1
%patch46 -p1
%patch47 -p1
%patch48 -p1
%patch49 -p1
%patch50 -p1

%build
%configure
make
gzip -9 ChangeLog

%install
rm -fr %{buildroot}

%makeinstall
(cd doc/examples ; make clean ; rm -rf .deps Makefile Makefile.in)
gzip -9 doc/libxml2-api.xml
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la

%clean
rm -fr %{buildroot}

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%defattr(-, root, root)

%doc AUTHORS ChangeLog.gz NEWS README Copyright TODO
%doc %{_mandir}/man1/xmllint.1*
%doc %{_mandir}/man1/xmlcatalog.1*
%doc %{_mandir}/man3/libxml.3*

%{_libdir}/lib*.so.*
%{prefix}/bin/xmllint
%{prefix}/bin/xmlcatalog

%files devel
%defattr(-, root, root)

%doc %{_mandir}/man1/xml2-config.1*
%doc AUTHORS ChangeLog.gz NEWS README Copyright TODO
%doc doc/*.html doc/html doc/*.gif doc/*.png
%doc doc/tutorial doc/libxml2-api.xml.gz
%doc doc/examples
%doc %dir %{_datadir}/gtk-doc/html/libxml2
%doc %{_datadir}/gtk-doc/html/libxml2/*.devhelp
%doc %{_datadir}/gtk-doc/html/libxml2/*.html
%doc %{_datadir}/gtk-doc/html/libxml2/*.png
%doc %{_datadir}/gtk-doc/html/libxml2/*.css

%{_libdir}/lib*.so
%{_libdir}/*a
%{_libdir}/*.sh
%{prefix}/include/*
%{prefix}/bin/xml2-config
%{prefix}/share/aclocal/libxml.m4
%{_libdir}/pkgconfig/libxml-2.0.pc
%files python
%defattr(-, root, root)

%doc AUTHORS ChangeLog.gz NEWS README Copyright
%{_libdir}/python*/site-packages/libxml2.py*
%{_libdir}/python*/site-packages/drv_libxml2.py*
%{_libdir}/python*/site-packages/libxml2mod*
%doc python/TODO
%doc python/libxml2class.txt
%doc python/tests/*.py
%doc doc/*.py
%doc doc/python.html

%changelog
* Mon Nov 17 2014 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.25.el5
- CVE-2014-3660 denial of service via recursive entity expansion (rhbz#1161841)

* Tue Jul 23 2013 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.24.el5
- fixed one regexp bug and added a (rhbz#922450)
- Another small change on the algorithm for the elimination of epsilon (rhbz#922450)

* Tue Feb 19 2013 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.23.el5
- detect and stop excessive entities expansion upon replacement (rhbz#912573)

* Mon Jan 28 2013 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.22.el5
- fix validation issues with some XSD (rhbz#877348)
- xmlDOMWrapCloneNode discards namespace of the node parameter (rhbz#884707)

* Thu Nov 29 2012 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.21.el5
- fix out of range heap access (CVE-2012-5134)

* Wed Sep  5 2012 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.20.el5
- Implement some default limits in the XPath module (CVE-2011-1944)
- Change the XPath code to percolate allocation errors (CVE-2011-1944)

* Wed Aug 22 2012 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.19.el5
- Fix an off by one pointer access (CVE-2011-3102)

* Tue Aug 21 2012 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.18.el5
- Fix parser local buffers size problems (rhbz#843740)
- Fix entities local buffers size problems (rhbz#843740)
- Fix an error in previous commit (rhbz#843740)

* Mon Feb 13 2012 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.17.el5
- fix previous build to force compilation of randomization code
- Resolves: rhbz#788844

* Fri Feb 10 2012 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.16.el5
- adds randomization to hash and dict structures CVE-2012-0841
- Resolves: rhbz#788844

* Fri Jan  6 2012 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.15.el5
- Fix the semantic of XPath axis for namespace/attribute nodes CVE-2010-4008
- Fix an off by one error in encoding CVE-2011-0216
- Fix some potential problems on reallocation failures CVE-2011-1944
- Fix missing error status in XPath evaluation CVE-2011-2834
- Make sure the parser returns when getting a Stop order CVE-2011-3905
- Fix an allocation error when copying entities CVE-2011-3919.patch
- Resolves: rhbz#771907

* Fri Oct 21 2011 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.14
- fix schemas validation of empty integer values (rhbz#743737)

* Tue Jun 28 2011 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.13
- Fix a potential crasher in XPath or XSLT, CVE-2011-1944
- Resolves: rhbz#710395

* Thu Apr 21 2011 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.12
- fix various problems with XSD validation
- Resolves: rhbz#644312

* Mon Oct  4 2010 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.11
- missing an initialization in an XPath internal structure
- Resolves: rhbz#613860

* Tue Aug  4 2009 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.10
- Fix a couple of crash CVE-2009-2414 and CVE-2009-2416
- Resolves: rhbz#515237

* Wed Nov 12 2008 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.9
- two patches for size overflows problems CVE-2008-4225 and CVE-2008-4226
- Resolves:  rhbz#470475

* Fri Sep  5 2008 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.8
- Patch to fix an entity name copy buffer overflow CVE-2008-3529
- Resolves: rhbz#461024

* Thu Aug 28 2008 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.7
- Patch to fix recursive entities handling CVE-2008-3281 in a better way
- Resolves: rhbz#458096

* Sat Aug 23 2008 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.6
- Patch to fix recursive entities handling CVE-2008-3281
- Resolves: rhbz#458096

* Mon Dec 17 2007 Daniel Veillard <veillard@redhat.com> - 2.6.26-2.1.3
- Patch to fix UTF-8 decoding problem CVE-2007-6284
- Resolves: rhbz#425934

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 2.6.26-2.1.2
- fixing an i386/x86_64 parallel install problem of -devel
- Resolves: rhbz#222735

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 2.6.26-2.1.1
- rebuild

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 2.6.26-2.1
- rebuild

* Wed Jun  7 2006 Daniel Veillard <veillard@redhat.com> 2.6.26-2
- fix bug #192873
* Tue Jun  6 2006 Daniel Veillard <veillard@redhat.com> 2.6.26-1
- upstream release 2.6.26 see http://xmlsoft.org/news.html

* Tue Jun  6 2006 Daniel Veillard <veillard@redhat.com>
- upstream release 2.6.25 broken, do not ship !

